﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraShake : MonoBehaviour 
{

	public float shakeTimer; 
	public float shakeAmount;

	private bool isShaking;
	private Vector3 startPosition; 
	private float currentShakeTimer; 

	// Use this for initialization
	void Start () 
	{
		startPosition = transform.position;
		isShaking = false;
	}

	void FixedUpdate ()
	{ 

	}

	// Update is called once per frame
	void Update () 
	{
		startPosition = transform.position;

		if (Input.GetKeyDown(KeyCode.T)) 
		{ 
			ShakeCamera (0.1f, 1f);
		}

		if (shakeTimer >= 0) { 
			Vector2 shakePos = Random.insideUnitCircle * shakeAmount;

			transform.position = new Vector3 (transform.position.x + shakePos.x, transform.position.y + shakePos.y, transform.position.z);

			shakeTimer -= Time.deltaTime;
		} 
		else if (isShaking) 
		{ 
			if (transform.position != startPosition) 
			{ 
				transform.position = startPosition;
			}
			isShaking = false;
		}


	}

	public void ShakeCamera(float shakePower, float shakeDuration)
	{ 
		shakeAmount = shakePower;
		shakeTimer = shakeDuration;
		isShaking = true;
	}
}

