﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class MenuMovement : MonoBehaviour
{
    public GameObject[] foods;
    public float speed;
    public float oldAngle;
    public float angle;
    public const float defaultSpeed = 0.03125f;
    public const float deceleration = 0.001953125f;
    public const float topForward = 0.125f;
    public const float topBack = -0.0625f;
    public const float turnSpeed = 3.0f;
    public const int maxFoods = 10;
    public const int startTime = 15;
    public float timeToStart;
    public bool started;
    public bool isDead;
    public int score;
    public float timeLeft;
    Dictionary<string, int> Feet = new Dictionary<string, int>();
    public bool moving;
    public Text timer;
    public Text scoreBoard;

    public Animator charAnim;

    // Use this for initialization
    void Start()
    {
        timeLeft = startTime;
        timeToStart = 3;
        score = 0;
        isDead = false;
        started = false;
        angle = 0; //= Random.Range(0, 360);
        Feet.Add("Left", 0);
        Feet.Add("Right", 0);
        moving = false;
        speed = 0.0f;
        // TEST FOR WHAT CONTROLLERS WORK.
        /*string[] control = Input.GetJoystickNames();
        foreach (string contName in control)
        {
            Debug.Log(contName.ToString());
        }*/
        // Get all the foods.
    }

    void FixedUpdate()
    {
        // If countdown Finished.
        if (started&&!isDead)
        {
            oldAngle = angle;
            // Setting player Speed/Angle.
            // No steps, slow down.
            if ((Feet["Left"] == 0) && (Feet["Right"] == 0))
            {
                // No feet moving, slow down to default shambling.
                if (speed < defaultSpeed)
                {
                    if (defaultSpeed - speed < deceleration)
                    {
                        speed = defaultSpeed;
                    }
                    else
                    {
                        speed = speed + deceleration;
                    }
                }
                else if (speed > defaultSpeed)
                {
                    if (speed - defaultSpeed < deceleration)
                    {
                        speed = defaultSpeed;
                    }
                    else
                    {
                        speed = speed - deceleration;
                    }
                }
            }
            // IF A FOOT MOVES WE ADJUST SPEED AND/OR ANGLE.
            else
            {
                //Debug.Log(Feet["Left"] + "Move" + Feet["Right"]);
                // Both feet forward. FASTER
                if ((Feet["Left"] > 0) && (Feet["Right"] > 0))
                {
                    speed = speed + 2 * deceleration;
                    if (speed > topForward)
                    {
                        speed = topForward;
                    }
                }
                // Both feeet backward. SLOWER/RETREAT
                else if ((Feet["Left"] < 0) && (Feet["Right"] < 0))
                {
                    speed = speed - 2 * deceleration;
                    if (speed < topBack)
                    {
                        speed = topBack;
                    }
                }
                // WHEN TURNING, IF FEET TURN OPPOSITE WAY, TURN QUICKER, STOP MOVING.
                // Left foot rotating forward
                else if (Feet["Left"] > 0)
                {
                    // Right foot Rotating back
                    if (Feet["Right"] < 0)
                    {
                        angle = angle - 2 * turnSpeed;
                        speed = 0;
                    }
                    // Right foot still
                    else
                    {
                        angle = angle - turnSpeed;
                    }

                }
                // Left foot rotating backward
                else if (Feet["Left"] < 0)
                {
                    // Right foot Rotating forward
                    if (Feet["Right"] > 0)
                    {
                        angle = angle + 2 * turnSpeed;
                        speed = 0;
                    }
                    // Right foot still
                    else
                    {
                        angle = angle + turnSpeed;
                    }
                }
                // Left foot not rotating.
                else if (Feet["Left"] == 0)
                {
                    // Right foot Forward.
                    if (Feet["Right"] > 0)
                    {
                        angle = angle + turnSpeed;
                    }
                    // Right foot back.
                    else
                    {
                        angle = angle - turnSpeed;
                    }
                }
            }
            if (angle > 360)
            {
                angle = angle - 360;
            }
            else if (angle < 0)
            {
                angle = angle + 360;
            }
            //STILL DOES NOT FUCKING WORK!
            //transform.Translate(speed * Mathf.Cos(angle * Mathf.PI / 180), 0, speed * Mathf.Sin(angle * Mathf.PI / 180));
            transform.position += transform.forward * speed;
            Quaternion playerRotation = transform.rotation;
            Quaternion targetRotation = Quaternion.AngleAxis(-angle, Vector3.up);
            transform.rotation = Quaternion.RotateTowards(playerRotation, targetRotation, 180.0f * Time.deltaTime);
            GameObject child = transform.FindChild("Char_anim").gameObject;
            //child.transform.rotation = transform.rotation;
            child.transform.localRotation = Quaternion.identity;

            // NOPE
            //transform.rotation = Quaternion.Euler(0, angle - oldAngle, 0);
            // STILL NO
            //Player.transform.Rotate(Vector3.up, angle - oldAngle);
            // BREAK DANCING NOPE.
            //Vector3 lookAtPos = new Vector3(Mathf.Cos(angle * Mathf.PI / 180), 2, Mathf.Sin(angle * Mathf.PI / 180));
            //transform.LookAt(lookAtPos);
            // DISPLAY TIMER
        }
        else
        {
            timeToStart = timeToStart - Time.deltaTime;
            if (timeToStart < 0)
            {
                started = true;
                charAnim.SetTrigger("startWalk");
            }
        }
    }

    // Update is called once per frame
    void Update()
    {
        Feet["Left"] = (int)Input.GetAxis("LeftLeg");
        Feet["Right"] = (int)Input.GetAxis("RightLeg");
        // SETTING FEET ANIMATION
        if (Feet["Right"] == 0)
        {
            charAnim.SetTrigger("rightSlow");
        }
        else
        {
            charAnim.SetTrigger("rightFast");
        }
        if (Feet["Left"] == 0)
        {
            charAnim.SetTrigger("leftSlow");
        }
        else
        {
            charAnim.SetTrigger("leftFast");
        }
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.gameObject.tag == "Obstacle")
        {
            speed = 0;
            charAnim.SetTrigger("turtle");
            isDead = true;
        }
    }
}